f// TermoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Termo.h"
#include "TermoDlg.h"
#include "mmsystem.h"
#include "divers.h"
#include "config.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTermoDlg dialog

CTermoDlg::CTermoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTermoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTermoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTermoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTermoDlg)
	DDX_Control(pDX, IDC_DG4, m_Digit4);
	DDX_Control(pDX, IDC_DG3, m_Digit3);
	DDX_Control(pDX, IDC_DG2, m_Digit2);
	DDX_Control(pDX, IDC_DG1, m_Digit1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTermoDlg, CDialog)
	//{{AFX_MSG_MAP(CTermoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTermoDlg message handlers
#define IDM_CONFIG 0x0020
#define IDM_ONTOP 0x0030

BOOL CTermoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	ASSERT((IDM_CONFIG & 0xFFF0) == IDM_CONFIG);
	ASSERT(IDM_CONFIG < 0xF000);

	ASSERT((IDM_ONTOP & 0xFFF0) == IDM_ONTOP);
	ASSERT(IDM_ONTOP < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);

	pSysMenu->RemoveMenu(SC_MAXIMIZE,MF_BYCOMMAND);
	pSysMenu->RemoveMenu(SC_SIZE,MF_BYCOMMAND);
	pSysMenu->RemoveMenu(SC_RESTORE,MF_BYCOMMAND);
 
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_CONFIG,"Confi&guration");
		pSysMenu->AppendMenu(MF_STRING, IDM_ONTOP,"Toujours &visible");
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	currentRaw=10000;		// Valeur courante du port => non connecte
	currentTemp=1000.0F;		// Temperature courante => hors range

	int timerId;
	if ((timerId = SetTimer(0,TIMER_SCALE,NULL))==0)			// Toute les 0.5 secondes
	{
		// Can't initialise timer
	}
  
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTermoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if ((nID & 0xFFF0) == IDM_CONFIG)
	{
		Cconfig configDialog(tCalibration,&currentPort);
		configDialog.DoModal();
	}
	else if ((nID & 0xFFF0) == IDM_ONTOP)
	{
		CMenu* pSysMenu = GetSystemMenu(FALSE);
		UINT checkState=pSysMenu->GetMenuState(IDM_ONTOP,MF_BYCOMMAND);
		checkState^=MF_CHECKED|MF_UNCHECKED;
		pSysMenu->CheckMenuItem(IDM_ONTOP,MF_BYCOMMAND|checkState);

		if (checkState==MF_CHECKED)
		{
			SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
		}
		else
		{
			SetWindowPos(&wndNoTopMost,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
		}
 	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTermoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTermoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTermoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	ReadTemperature(&currentRaw,&currentTemp,currentPort);

	// Je n'arrive pas a faire afficher mes bitmaps dans le OnPaint
	// Si quelqu'un peut me dire pourquoi ???

	CBitmap bitmapsDigits[4];
	DrawDigit(bitmapsDigits);
	//UpdateWindow();
	RedrawWindow();
	
	CString string;
	if (IsIconic())
	{
		string.Format("Termo (port %d):% 5.1fC",currentPort+1,currentTemp);
	}
	else
	{
		string.Format("Termo (port %d)",currentPort+1);
	}
	SetWindowText(string);

	CDialog::OnTimer(nIDEvent);
}


void CTermoDlg::DrawDigit(CBitmap *pBitmaps)
{
	static int digitTable[]=
	{	// SmallDigit
		IDB_DG_0,IDB_DG_1,IDB_DG_2,IDB_DG_3,IDB_DG_4,
		IDB_DG_5,IDB_DG_6,IDB_DG_7,IDB_DG_8,IDB_DG_9,
		IDB_DG_MINUS,IDB_DG_NULL,
		// BigDigit
		IDB_BDG_0,IDB_BDG_1,IDB_BDG_2,IDB_BDG_3,IDB_BDG_4,
		IDB_BDG_5,IDB_BDG_6,IDB_BDG_7,IDB_BDG_8,IDB_BDG_9,
		IDB_BDG_MINUS,IDB_BDG_NULL,
	};

	int i,j,digitId[4];
	char str[10];

	if (currentTemp>=-99.9F && currentTemp<=999.9F)
		sprintf(str,"%5.1f",currentTemp);
	else
		sprintf(str,"---.-");

	for (i=j=0; i<5; i++)
	{
		char c=str[i];
		if (c!='.')
		{
			int idx;
			switch (c)
			{
				case '-':
					idx=10;
					break;
				case ' ':
					idx=11;
					break;
				default:
					idx=c-'0';
			}
			digitId[j++]=digitTable[idx];
		}
	}

	pBitmaps[0].LoadBitmap(digitId[0]);
	pBitmaps[1].LoadBitmap(digitId[1]);
	pBitmaps[2].LoadBitmap(digitId[2]);
	pBitmaps[3].LoadBitmap(digitId[3]);
#if 1
	UpdateData();
	m_Digit1.SetBitmap((HBITMAP)pBitmaps[0]);
	m_Digit2.SetBitmap((HBITMAP)pBitmaps[1]);
	m_Digit3.SetBitmap((HBITMAP)pBitmaps[2]);
	m_Digit4.SetBitmap((HBITMAP)pBitmaps[3]);
	UpdateData(FALSE);
#endif
}
