
#include "stdafx.h"
#include "profile.h"
#include "divers.h"


void WriteConfiguration(void)
{
	int i;
	char name[_MAX_PATH];
	char data[_MAX_PATH];
	CWinApp* pApp = AfxGetApp();

	for (i=0; i<4; i++)
	{
		sprintf(name,"Port%d",i);
		sprintf(data,"%d %f %d %f",tCalibration[i].raw1,tCalibration[i].temp1,tCalibration[i].raw2,tCalibration[i].temp2);
		pApp->WriteProfileString("Calibration",name,data);
	}
}

void ReadConfiguration(void)
{
	int i;
	char name[_MAX_PATH];
	char def[_MAX_PATH];
	CString data;
	CWinApp* pApp = AfxGetApp();

	for (i=0; i<4; i++)
	{
		sprintf(name,"Port%d",i);
		sprintf(def,"%d %f %d %f",tCalibration[i].raw1,tCalibration[i].temp1,tCalibration[i].raw2,tCalibration[i].temp2);
		data=pApp->GetProfileString("Calibration",name,def);
		sscanf((LPCTSTR)data,"%d %f %d %f",&tCalibration[i].raw1,&tCalibration[i].temp1,&tCalibration[i].raw2,&tCalibration[i].temp2);
	}
}